#include <stdio.h>
#include <stdlib.h>

template<class T>
T rump(T x, T y) {
    T x2, y2, y4, y6, y8, R1, R2, R3, R;
    T df1 = 333.75, df2= 11.0, df3=121.0, df4=2.0, df5=5.5;

    x2 = x*x;
    y2 = y*y;
    y4 = y2*y2;
    y6 = y4*y2;
    y8 = y4*y4;
    R1 = df1*y6 + x2*(df2*x2*y2 - y6 - df3*y4 - df4);
    R2 = df5*y8;
    R3 = x/(df4*y);
    R  = R1 + R2 + R3;
    return(R);
}


int main(void) {
    float  fR;
    double dR;
    long double ldR;

    printf("\nEvaluacion del polinomio de Rump\n\n");
    printf("-------- Resultados con variables tipo float       -------\n");
    fR = rump<float>(77617.0, 33096.0);
    printf("R(77617, 33096) =  %1.17e \n\n", fR);


    printf("-------- Resultados con variables tipo double      -------\n");
    dR = rump<double>(77617.0, 33096.0);
    printf("R(77617, 33096) =  %1.17e \n\n", dR);

    printf("-------- Resultados con variables tipo long double -------\n");
    ldR = rump<long double>(77617.0, 33096.0);
    printf("R(77617, 33096) =  %1.17Le \n\n", ldR);
}

